#!/bin/sh
#
# Restart firefox browser on raspberry pi with url for a different computer
#
Raspis="raspi3s|raspi4h|raspi3h"; Ruser="pi"
Comps="mandria|macstudio|tormenta"; Cuser="cs"
Usage="Usage:\t`basename "$0"` $Raspis $Comps\n"
Usage+="\tRestart browser on $Raspis with url for $Comps"
#
if [ $# -ne 2 ]; then echo "$Usage"; exit 1; fi
Raspi=$1; Url=$2
eval "case \"$Raspi\" in $Raspis) ;; *) echo -e \"$Usage\"; exit 1;; esac"
eval "case \"$Url\" in $Comps) ;; *) echo -e \"$Usage\"; exit 1;; esac"
echo "Start Firefox on $Ruser@$Raspi with URL http://$Url/~$Cuser"
ssh $Ruser@$Raspi "pgrep firefox-esr && killall firefox-esr; export DISPLAY=:0;nohup firefox-esr --kiosk http://$Url/~$Cuser >/dev/null 2>&1 &"
exit 0
