program DisplayPlaylist;

{$mode objfpc}{$H+}

uses
  {$IFDEF UNIX}{$IFDEF UseCThreads}
  cthreads,
  {$ENDIF}{$ENDIF}
  Interfaces, // this includes the LCL widgetset
  Forms, displayplaylist_u1
  { you can add units after this };

{$R *.res}

begin
  RequireDerivedFormResource:=True;
  Application.Scaled:=True;
  Application.Initialize;
  Application.CreateForm(TDisplayPlaylistGUI, DisplayPlaylistGUI);
  Application.Run;
end.

// Conversion of AppleScript DisplayPlaylist program to Lazarus Pascal
// and runAsScript.scpt Applescript utility for mounting and unmounting
// the raspi "Home Directory" and reading of the Decibel or Music playlist.
//
// After successfull compilation:
// Execute: ./install.sh
//
// Initial Version Sep 01, 2020 - DisplayPlaylist V3.0
// Compiled with Lazarus Pascal 2.0.10
//
// Okt 12, 2020
// Some clean up in Applescript code
// Changed call of osascript from RunCommand (deprecated) to TProcess.
// In readPlaylist(): Added function seperateNumWithBlank()
// Added procedure readIniFile()
// DisplayPlaylist now immediately executes at start up
// In writePlaylist(): Crop theArtist + theTitle to 2 * cropAt max
//
// Okt 21, 2020
// Removed 'Start' and 'Stop' Buttons. Now it is possible to change the
// Host System, Advertising and Music Player without stopping.
//
// Okt 24, 2020
// Added [WindowPosition] Section to .DisplayPlaylist.ini to load the
// window position on program start and to save the current window
// position on program exit.
//
// Feb 28, 2021
// Changed/Added Comments for nearly every procedure and compiled
// under Lazarus Pascal 2.0.12
//
// May 8, 2021
// install.sh now installs DisplayPlaylist App on local Mac
// and on remote Macs. Created new Icon File.
//
// May 16, 2021 - DisplayPlaylist V3.1
// Installed Lazarus Pascal 2.1.0 with fpc-3.3.1 on my M1 MacBook Air and
// created a Universal Binary for aarch64 and x86_64 of DisplayPlaylist
//
// Aug 17, 2021 - DisplayPlaylist V3.2
// Added "runAsScriptProg=ScriptFile.scpt" option to .DisplayPlaylist.ini.
// If 'ScriptFile.scpt' does not exist, defaults to 'runAsScript7Tracks.scpt'.
// Display AppleScript name, PlayerStatus and CurrentSong in the GUI.
//
// Aug 19, 2021 - DisplayPlaylist V4.0
// Major rewrite. Now, all html files reside under $HOME/Sites on the Mac.
// writePlaylist() directly writes the current playlist to 'DisplayPlaylist.htm'
// when the player is playing or copies 'Advertising.htm', 'Clock.htm' or
// 'Video.htm' to 'DisplayPlaylist.htm'.
// For this to work, a web server is needed on the Mac.
//
// Aug 22, 2021
// Added macHomeDir and browserUrl options to .DisplayPlaylist.ini.
// If option is not set, macHomeDir defaults to '/Users/$USER/Sites/' and
// browserUrl defaults to 'http://$HOSTNAME/~$USER'.
// It is now possible to start a browser on the Mac from the GUI.
// Compiled for aarch64 and X86_64 with Lazarus 2.3.0 and fpc 3.2.2
//
// Aug 24, 2021 - DisplayPlaylist V4.0.1
// Fixed some bugs in the handling of the ComboBoxes.
//
// Aug 30, 2021
// Write 'Advertising' and 'musicPlayer' to 'DisplayPlaylist.ini' on exit.
//
// Sep 7, 2021
// Changed name from 'macHomeDir' to 'macSitesDir'.
//
// Aug 8, 2023 - DisplayPlaylist V4.0.2
// Allow multiple numbers in seperateNumWithBlank function.
// Set ShowAccelChar option in LabelCurrentSong to False
// to correctly display the '&' sign.
