#!/bin/bash
#
HostArray="cs@mandria cs@macstudio cs@tormenta"
SitesFlag="RsyncSites"	# Rsync Sites directory, even if not empty
#SitesFlag=""			# Rsync Sites directory only after asking for permission, if not empty
ThisPath=$(cd `dirname $0` && pwd)
AppPath="/Applications/DisplayPlaylist.app"
HostName=`hostname -s`; User=`id -u -n`
HOME="/Users/$User"; MacHomeDir="/Users/$User/Sites"
Flag=""; IniFlag="--ignore-existing"; Answer=false
#
# Build usage string from HostArray and check command line arguments
Usage="Usage: install.sh\t[-n|-i|-ni|-in] [all|"; for UserHost in $HostArray; do Usage="$Usage$UserHost|"; done
Usage="$Usage]"; Usage=${Usage//|]/] }  # Replace last occurence of |] with ]
Usage+="\n\t\t\tWithout argument installs on $User@$HostName"
Usage+="\n\t\t\t-n - Perform a trial run with no changes made"
Usage+="\n\t\t\t-i - Copy .DisplayPlaylist.ini file, even if it already exists"
#
case $OSTYPE in darwin*) ;; *) echo "Has to be executed on a Mac"; exit 1;; esac
case $1 in -i) IniFlag=""; shift;; -n) Flag="-n"; shift;; -ni|-in) IniFlag="";FLAGS="-n"; shift;; *) ;; esac
if [ $# -gt 1 ]; then echo "$Usage"; exit 1; fi
if [ $# -eq 0 ]; then HostArray="$User@$HostName";Host="$User@$HostName"; fi
if [ $# -eq 1 ]; then Host=$1; fi
eval "case $Host in	  all) ;; ${HostArray// /|}) HostArray=$Host;; *) echo -e \"$Usage\"; exit 1;; esac"
#echo "$# HOME: $HOME Flag: $Flag IniFlag: $IniFlag Hostarray: $HostArray Host: $LocalHost"; exit
#
# Rsync Resouces/ directory to DisplayPlaylist.app/Contents/Rescouces directory
echo "rsync $Flag -a --delete Resources/ DisplayPlaylist.app/Contents/Resources/"
rsync $Flag -a --delete Resources/ DisplayPlaylist.app/Contents/Resources/
#
# Rsync DisplayPlaylist.app/ to $AppPath of hosts in $HostArray
# Rsync DisplayPlaylist/Sites/ to $MacHomeDir Directory of hosts in $HostArray
#
for UserHost in $HostArray; do
	IFS_BAK=$IFS;IFS='@'; set $UserHost; IFS=$IFS_BAK; User=$1; Host=$2
	nc -z -v -w 30 $Host 22 >/dev/null 2>&1		# Check if host is alive
	if [ $? -eq 0 ]; then
		# Rsync DisplayPlaylist App to host
		echo "Rsync DisplayPlaylist.app/ and Sites/ files to $UserHost"
		echo "Rsync $Flag -La --rsync-path="sudo rsync" --delete --chmod=755 $ThisPath/DisplayPlaylist.app/ $UserHost:$AppPath/"
		rsync $Flag -La --rsync-path="sudo rsync" --delete --chmod=755 $ThisPath/DisplayPlaylist.app/ $UserHost:$AppPath/
		# Rsync .DisplayPlaylist.ini file to host - force copy, if -i flag is present
		echo "Rsync $Flag -a $IniFlag  --chmod=755 $ThisPath/.DisplayPlaylist.ini $UserHost:$HOME/.DisplayPlaylist.ini"
		rsync $Flag -a $IniFlag --chmod=755 $ThisPath/.DisplayPlaylist.ini $UserHost:$HOME/.DisplayPlaylist.ini
		# Is ~/Sites directory on host empty? If not, ask for permission to rsync anyway. Don't ask, if $SitesFlag="RsyncSites"
		if [ ! "$(ssh $UserHost ls -A $MacHomeDir 2>/dev/null)" == "" ]; then
			if [ $SitesFlag = "RsyncSites" ]; then Answer="y"; fi
			while [ $Answer != y -a $Answer != n ]; do
				read -p "Directory $UserHost:$MacHomeDir not empty. Do you really want to proceed (y/n)? " Answer
			done
			case $Answer in y) ;; *) echo "Rsync to Directory aborted"; exit ;; esac; fi
		echo "Rsync $Flag -a --delete --chmod=755 $ThisPath/Sites/ $UserHost:$MacHomeDir/"
		rsync $Flag -a --delete --chmod=755 $ThisPath/Sites/ $UserHost:$MacHomeDir/
	else echo "Host $Host is currently down"; fi; done; exit 0
