#!/bin/bash
#
App="DisplayPlaylist"; Arm="arm64"; X86="x86_64"; Copy="rsync -aq"
Usage="Usage:\tmk_app.sh [copy|$Arm|$X86|universal|thin|print]"
Usage+="\n\tcopy - copy $App to the right architecture .$Arm or .$X86"
Usage+="\n\tarm64|x86|universal - create $App binary"
Usage+="\n\tthin - Recreate $Arm and $X86 binaries from universal binary"
Usage+="\n\tprint - print displayplaylist_u1.pas to displayplaylist_u1.ps as Postscript"
#
copyfile () {
	if [ ! -f $1 ]; then echo "$1 does not exist"; exit 1; fi
	if [ $1 -ot $2 ]; then echo "$1 is older than $2"; exit 1; fi
	echo "$Copy $1 $2"; $Copy $1 $2; file $2
}
#
if [ $# -ne 1 ]; then echo -e "$Usage"; exit 1; fi
case $1 in
	copy)		if [ ! -f $App ]; then echo "$App does not exist"; exit 1; fi
				R=`file $App|grep -c $Arm`
				if [ $R -eq 2 ]; then echo "$App is already a universal binary"; exit 1; fi
				if [ $R -eq 1 ]; then copyfile $App $App.$Arm; fi
				R=`file $App|grep -c $X86`
				if [ $R -eq 1 ]; then copyfile $App $App.$X86; fi;;
	arm64)		copyfile $App.$Arm $App;;
	x86_64)		copyfile $App.$X86 $App;;
	universal)	if [ ! -f $App.$X86 ]; then echo "$App.$X86 does not exist"; fi
				if [ ! -f $App.$Arm ]; then echo "$App.$Arm does not exist"; fi
				echo "Both $Arm and $X86 binaries exist - creating universal binaary"
				echo "lipo -create -output $App $App.$X86 $App.$Arm"
				lipo -create -output $App $App.$X86 $App.$Arm
				echo "strip $App"; strip $App; file $App;;
	thin)		if [ ! -f $App ]; then echo "$App does not exist"; exit 1; fi
				R=`file $App|grep -c $Arm`
				if [ $R -ne 2 ]; then echo "$App is not a universal binary"; exit 1; fi
				echo "Creating $App.$Arm and $App.$X86 binaries"
				lipo $App -thin $Arm -output $App.$Arm; file $App.$Arm
				lipo $App -thin $X86 -output $App.$X86; file $App.$X86;;
	print)		a2ps -R --columns=1 --chars-per-line=90 displayplaylist_u1.pas -o displayplaylist_u1.ps;;
	*)			echo -e "$Usage"; exit 1;; esac
exit 0
