#!/usr/bin/env bash
#
# Setup apache server on a Mac for DisplayPlaylist
#
ConfigChange="No"; User="$USER"
case $OSTYPE in darwin*) ;; *) echo "Hast to be executed on a Mac"; exit 1;; esac
Mac=$(cat /etc/hostname | tr "[:upper:]" "[:lower:]")    # Get hostname and convert to lower case
read -p "Do you want to setup apache server for $User@$Mac? ([y]es or [n]o): " Doit
            case $(echo $Doit | tr '[A-Z]' '[a-z]') in
            y|yes) echo "Setting up apache server for $User@$Mac" ;; *) echo "Aborting program"; exit 1 ;; esac
#
# Setup  /etc/apache2/httpd.conf
#
HttpConf="/etc/apache2/httpd.conf"
for i in mod_userdir.so httpd-userdir.conf; do
	R=$(grep "^\s*#\s*.*$i"  $HttpConf)
	if [ "$R" != "" ]; then
		ConfigChange="Yes"
		sudo bash -c "sed -i.bak \"/$i/ s/^#//\" $HttpConf"
	else echo "$i already activated"; fi
done
R=$(grep "^#ServerName.*" $HttpConf)
if [ "$R" != "" ]; then
	ConfigChange="Yes"
	sudo bash -c "sed -i.bak \"s/^#ServerName.*/ServerName $Server/\" $HttpConf"
else echo "ServerName already set to $Server"; fi
if [ -f $HttpConf.bak ]; then echo "Remove $HttpConf.bak"; sudo rm $HttpConf.bak; fi
#
# Setup /private/etc/apache2/extra/httpd-userdir.conf
#
HttpUserDir="/private/etc/apache2/extra/httpd-userdir.conf"
R=$(grep "^#Include.*" $HttpUserDir)
if [ "$R" != "" ]; then
	ConfigChange="Yes"
	sudo bash -c "sed -i.bak \"/^#Include/ s/^#//\" $HttpUserDir"
else echo "$HttpUserDir already configured"; fi
if [ -f $HttpUserDir.bak ]; then echo "Remove $HttpUserDir.bak"; sudo rm $HttpUserDir.bak; fi
#
# Create /etc/apache2/users/$User.conf, if it does not exist
#
if [ -f /etc/apache2/users/$User.conf ]; then echo "/etc/apache2/users/$User.conf already exists"; else
ConfigChange="Yes"
sudo bash -c "(cat <<EOL
<Directory "/Users/$User/Sites/">
    AllowOverride All
    Options Indexes MultiViews FollowSymLinks
    Require all granted
</Directory>
EOL
) > /etc/apache2/users/$User.conf"; fi
#
# Check configuration
#
apachectl configtest
#
# Restart apache server, if configuration has changed
#
if [ "$ConfigChange" = "Yes" ]; then echo "Restart apache server"; sudo apachectl restart
else echo "No restart of apache server needed"; fi
